<?php

defined('is_running') or die('Not an entry point...');

gpPlugin_incl('Gadget.php');

class RifBackgroundsChangerAdmin extends RifBackgroundsChanger{


	function __construct(){

		parent::__construct();

		$cmd = common::GetCommand();
		switch($cmd){
			case 'Show_Config':
				$this->Show_Config();
			break;			
			case 'SaveBackgroundsConfig';
				$this->SaveBackgroundsConfigA();
				$this->Show_Config();
			break;
			case 'DeleteBackgroundsStyle';
				$this->SaveBackgroundsConfig(true);
				$this->Show_Config();
			break;
			case 'SaveBackgrounds':
				$this->SaveBackgrounds();
				$this->Show_Pages();
			break;
			case 'OrganizeTemplates':
				$this->OrganizeTemplates();
				//$this->Show_Pages();
			break;
			case 'SaveTemplate':
				$this->SaveOrganizeTemplates();
				$this->Show_Pages();
			break;			
			case 'UploadFile':
				$this->UploadFile();
			exit;
			default:
			$this->Show_Pages();
		}

	}

	static function UploadFile(){
		global $dataDir, $langmessage;
		
		//$_REQUEST['dir'] = "/image";		
		header('Content-type:application/json;charset=utf-8');
	
		if(!isset($_REQUEST['dir']) && $_REQUEST['dir'] != ""){
			echo json_encode(['status' => 'error', 'message' => 'No Dir']);
			return;
		}
		
		if($_REQUEST['dir'][0] != "/")
			$_REQUEST['dir'] = "/".$_REQUEST['dir'];
		
		if( empty($_FILES['file']['name']) or  empty($_FILES['file']['tmp_name'])){
			echo json_encode(['status' => 'error', 'message' => 'Empty Name']);
			return;
		}	 	

		$baseDir = '/data/_uploaded';
		$path = $_REQUEST['dir'].'/';
		$file = $_FILES['file']['name'];
		//$filesa = \gp\admin\Content\Uploaded::SanitizeName($file);

		$from = $_FILES['file']['tmp_name'];
		$to = $dataDir.$baseDir.$path.$file;		

		//upload image
		if( !move_uploaded_file($from, $to) ){
			echo json_encode(['status' => 'error', 'message' => $langmessage['UPLOAD_ERROR'].' (Move Upload Failed) '.$file]);
			return;
		}
		
		@chmod( $to, gp_chmod_file);
		
		//greate thumbnail			
		\gp\admin\Content\Uploaded::CreateThumbnail($to);
		
		// All good, send the response		
		echo json_encode(['status' => 'ok','path' => $path.$file, 'info' => $to]);
		
	}
	
	
	function Show_adminhead($conf=false){
		global $langmessage, $gp_titles, $addon_current_id;
		
		$gpabox = false;
		if(isset($_REQUEST['gpabox']))
			$gpabox = true;	

		$H1 = '<h2>'.self::AdminTextTranslates('Backgrounds Changer').'</h2>';
		if($conf){
			$addlinks = common::Link('Admin_Backgrounds_Changer', self::AdminTextTranslates('Pages'), "", ' style="font-weight:bold"');
			$H2 =  '<h3>'.self::AdminTextTranslates('Syles Editor').'</h3>';
		}else{
			$addlinks = common::Link('Admin_Backgrounds_Changer', self::AdminTextTranslates('Configurations'), "cmd=Show_Config", ' style="font-weight:bold"');
			$H2 =  '<br/><h3>'.self::AdminTextTranslates('Pages').'</h3>';
		}
		if($gpabox){
			$addlinks = common::Link('Admin_Backgrounds_Changer', self::AdminTextTranslates('Configurations'), "cmd=Show_Config", ' style="font-weight:bold"');
			$H1 = $H2;
			$H2 = "";
		}
			
		echo $this->AdminHeader($H1, $addlinks, $H2);

	}
	
	
	function Show_styleprops($info){
		global $dirPrefix;

		foreach( $info as $style => $custom ){
			if(!is_array($custom))
				continue;
			$description = '';
			if (isset($this->config['styles'][$style]['description']))
				$description = htmlspecialchars($this->config['styles'][$style]['description']);
			if (isset($this->config['styles'][$style]['title']))
				echo common::Link('Admin_Backgrounds_Changer', $this->config['styles'][$style]['title'], "cmd=Show_Config&stylenr=".$style, ' style="color:#8f9014;" title="'.$description.'"').'<b>:</b>';
			if(isset($custom['color']))
				echo ' <a style="font-style: italic;display:inline-block;height:14px;width:16px;background:'.$custom['color'].'" title="'.$custom['color'].'"> &nbsp;&nbsp;&nbsp;&nbsp;</a>';
			if(isset($custom['img']))
				echo ' <a style="font-style: italic;" href="'.$dirPrefix.$custom['img'].'" name="gallery" rel="gallery_uploaded">'.basename($dirPrefix.$custom['img']).'</a> ';
			if(isset($custom['htmlelement']))
				echo ' <span style="font-style: italic;">'.$custom['htmlelement'].'</span> ';
			echo '<br>';	
		}
	}
	
	// two levels main menu with rif-multilag if installed
	function MenuPages(){
		global $gp_menu, $ml_object;
		
		$out = array();
		$lout = array();
		$langpages = self::LangPages();	
							
		foreach ($gp_menu as $_index => $level){
			
			//LEvel one
			if($level["level"] == 0){
				$key = $_index;

				$out[$key][$_index] = $_index;
				
				//langpages for rifMultilang plugin
				if (!empty($langpages) && isset($langpages[$key])){
					foreach($langpages[$key] as $l =>$p){
						$lkey = explode("-", $l);
						$lout[$lkey[1]][$key] = $langpages[$key];
					}
				}						
			}
			
			//level two
			if($level["level"] == 1 && $key){
				
				$out[$key][$_index] = $_index;
				
				//langpages for rifMultilang plugin
 				if (!empty($langpages) && isset($langpages[$_index])){
										
					if(!isset($langpages[$key])){
						foreach($langpages[$_index] as $l1 =>$p1){
							$lkey1 = explode("-", $l1);
							$lout[$lkey1[1]][$key] = $langpages[$_index];
						}

					}else{
						foreach($langpages[$key] as $l1 =>$p1){
							$lkey1 = explode("-", $l1);
							$lout[$lkey1[1]][$key] += $langpages[$_index];
						}
					}				

				}
													
			}			
		}
	
		//langpages for rifMultilang plugin
		if(	!empty($lout)){		
			foreach($lout as $languages => $pages){
				foreach($pages as $page => $lpage){
					if(isset($out[$page]))
						$out[$page] += $lpage;

				}		
			}
		}
		
		return $out;
	}


	function AffectedPagelink($index) {
		
		$showIndeks = "";
		$showIndeks = '<i style="font-size: 9px;"> ['.$index.']</i>'; // close line to not show
		$linkToPage = true; // close line to not link
		
		if(isset($linkToPage))
			return '<span class="AffectedPageList">'.common::Link_Page(common::indexToTitle($index)).$showIndeks.'</span>';
				
		return common::indexToTitle($index).$showIndeks;
	}


	// sort pages .... and if rif-multilang installed
	function SortPages() {	
		global $ml_object;
		
		$affected_pages = self::MenuPages();
		$menulevels = array();

		foreach($affected_pages as $index => $pages){

			$idx = $index;
			$def_page = false;
			$trns_page = false;
			$undrans = array();
				
			foreach ($pages as $key => $page){

				$lang = false;
				
				if(!isset($menulevels[$idx]["affected_pagelist"]))
					$menulevels[$idx]["affected_pagelist"] = "";
				
				//langpages for rifMultilang plugin
				if ($key != $page){
					
					$trns_page = $page;
				
					//first level trans
					$pl = explode("-", $key);
					$def_page = $pl[0];
					$lang = $pl[1];	
					
					if($def_page == $index)
						$idx = $page;
				}else{
					$undrans[] = $page;
				}					
				
				if(!isset($this->config['pages'][$page])){
				
					if($def_page && $def_page == $index){ 
						if(!isset($this->config['pages'][$trns_page])){
							$menulevels[$index]["affected_pagelist"] .= self::AffectedPagelink($page)." | ";
							$menulevels[$def_page]["flag"] = ' <img style="height:10px; width:20px;"  src="'.$ml_object->flags .'/'.$ml_object->lang.'.png">';
							$menulevels[$index]["flag"] .= ' <img title="'.self::AdminTextTranslates('Page').': '.common::indexToTitle($trns_page).'" style="cursor: pointer;height:10px; width:20px;" src="'.$ml_object->flags .'/'.$lang.'.png">';
						}							
					}else{
						
						if($lang && !array_key_exists($index."-".$lang, $pages)){
							
							if(!isset($menulevels[$def_page]["affected_pagelist"]))
								$menulevels[$def_page]["affected_pagelist"] = "---- ";

							if($page !==  $idx)
								$menulevels[$def_page]["menulevel"] = 1;
							
							$menulevels[$def_page]["affected_pagelist"] .= self::AffectedPagelink($page)."<br>";
							$menulevels[$def_page]["flag"] = ' <img style="height:10px; width:20px;"  src="'.$ml_object->flags .'/'.$ml_object->lang.'.png">';
							$menulevels[$def_page]["flag"] .= ' <img title="'.self::AdminTextTranslates('Page').': '.common::indexToTitle($trns_page).'" style="cursor: pointer;height:10px; width:20px;" src="'.$ml_object->flags .'/'.$lang.'.png">';							
						}else{

							$menulevels[$idx]["affected_pagelist"] .= self::AffectedPagelink($page)." | ";
						}

						if($idx == $page && !$lang){
							$menulevels[$idx]["def-template"] = '-Default-';
							$menulevels[$idx]["affected_pagelist"] = "";
						}					
								
					}					
			
				}else{
									
					$menulevels[$page] = $this->config['pages'][$page];
					
					if($page !==  $idx)
						$menulevels[$page]["menulevel"] = 1;

					//langpages for rifMultilang plugin
					if ($lang){
						if($page ==  $idx)
							foreach($undrans as $p){
								if(!isset($pages[$p."-".$lang])){
									if($p !== $idx)
										$menulevels[$idx]["affected_pagelist"] = "";
										$menulevels[$idx]["affected_pagelist"] .= self::AffectedPagelink($p)." | ";
								}
						}
						
						$menulevels[$page]["flag"] = '<img style="height:10px; width:20px;"  src="'.$ml_object->flags .'/'.$lang.'.png">';	
					
						if($def_page && $def_page == $index){
							$menulevels[$def_page]["flag"] = '<img style="height:10px; width:20px;"  src="'.$ml_object->flags .'/'.$ml_object->lang.'.png">';	
						}
					}					
					
				}
				
				$menulevels[$index]["break"] = $index;					
			}
	
		}

		
		//TopTwoMainMenu pluss others pages		
		$menuend = array("menuend" => "");		
		$this->config['pages'] = $menulevels+$menuend+$this->config['pages'];


		//___________________________
		// for rif-multilang plugin - sort pages outside of TopTwoMainMenu
		if (isset($ml_object->RifMultilang) && !empty($ml_object->lists)){
			
			$other = false;
			$otherpages = array();
			$langpages = self::LangPages();
				
			foreach ($this->config['pages'] as $p => $data){

				if ($p == "menuend"){
					$other = true;
					continue;
				}
				if(!$other)
					continue;
								
				if (!empty($langpages) && isset($langpages[$p])){
					
					$otherpages[$p] = $this->config['pages'][$p];
					unset($this->config['pages'][$p]);
					
					$otherpages[$p]["affected_pagelist"] = "";						
					$otherpages[$p]["flag"] = '<img style="height:10px; width:20px;"  src="'.$ml_object->flags .'/'.$ml_object->lang.'.png">'; 
					
					foreach($langpages[$p] as $l =>$lp){

						$lkey = explode("-", $l);
						
						if(isset($this->config['pages'][$lp])){
							$otherpages[$lp] = $this->config['pages'][$lp];
							unset($this->config['pages'][$lp]);							

							$otherpages[$lp]["flag"] = '<img style="height:10px; width:20px;"  src="'.$ml_object->flags .'/'.$lkey[1].'.png">';	
							
						}else{
							
							$otherpages[$p]["flag"] .= ' <img style="height:10px; width:20px;"  src="'.$ml_object->flags .'/'.$lkey[1].'.png">';								
							$otherpages[$p]["affected_pagelist"] .= self::AffectedPagelink($lp)." | ";
							
						}
					}
				}					
			}

			$this->config['pages'] += $otherpages;
		}		

	}

	
	function Show_Pages(){
		global $config, $langmessage, $gp_titles;

		self::Show_adminhead();
		
		$_js = '&nbsp;&nbsp;<b style="padding:1px;font-size:9px;border:2px solid black;">&nbsp;JS&nbsp;</b>&nbsp;&nbsp;';
		$_css = '&nbsp;&nbsp;<b style="padding:1px;font-size:9px;border:2px solid black;">&nbsp;CSS&nbsp;</b>&nbsp;&nbsp;';
		
		echo '<table class="bordered striped full_width">';
		echo '<thead><tr style="text-align:left"><th>'.self::AdminTextTranslates('Page').'<br><span style="font-weight: normal;"><i> & '.self::AdminTextTranslates('Affected pages').'</i></span></th><th>'.self::AdminTextTranslates('Template').'</th><th>'.self::AdminTextTranslates('Background styles and changes').'</th><th> </th></tr></thead>';
		echo '<tbody>';

		$firstItem = array('-Default-' => array());
		if(isset($this->config['default']))
			$firstItem = array('-Default-' => $this->config['default']);
		
		$mainmenu = self::AdminTextTranslates('Top Two Levels Main Menu').':';
		
		self::SortPages();		
		$pages = $firstItem + $this->config['pages'];

		foreach( $pages as $index => $info ){
						
			$affected_pagelist = "";
			if($index == "menuend"){
				$menuend = true;
				continue;
			}
			
			$spacer = "";
			If (isset($this->config['pages'][$index]["menulevel"]))
				$spacer = "---- ";				
			
			if (!empty($this->config['pages'][$index]["affected_pagelist"]))
				$affected_pagelist = rtrim($this->config['pages'][$index]["affected_pagelist"], "| ");
			
			$flag = ""; 
			if (isset($info['flag']))
				$flag = $info['flag'];
						
			//MENUBREAK COLUMN
			if (isset($this->config['pages'][$index]["break"])){			
				echo '<tr><td colspan="4">';
				echo '<b>'.$mainmenu.'</b><hr style =" margin-top: 0px;margin-bottom:0px;border:0;border-top:2px solid #aeb2d2;">';
				$mainmenu = "";
				echo '</td></tr>';
				unset($this->config['pages'][$index]["break"]);
			}
			
   			if (isset($menuend)){			
				echo '<tr><td colspan="4">';
				echo '<b>'.self::AdminTextTranslates('All other pages').':</b><hr style =" margin-top: 0px;margin-bottom:0px;border:0;border-top:2px solid #aeb2d2;">';
				echo '</td></tr>';
				unset($menuend);
			}			
			//MENUBREAK COLUMN END
			
			echo '<tr>';
			
			//PAGES COLUMN
			echo '<td>';			
			if($index == "-Default-")
				echo '<div style="white-space: nowrap;"><b>'.self::AdminTextTranslates($index).'</b>';	
			else	
				echo '<div style="white-space: nowrap;">'.$spacer.'<b>'.common::Link_Page(common::indexToTitle($index)).'</b> ['.$index.'] '.$flag.'</div>'.$affected_pagelist.'';
			echo '</td>';
			//PAGES COLUMN END
						
			//TEMPLATES COLUMN
			echo '<td>';
			if($index == '-Default-'){
				
				echo self::AdminTextTranslates('Default Template');
				
			}else if( !empty($info['template']) ){
				
				$description = '';
				if (isset($this->config['templates'][$info['template']]['description']))
					$description = htmlspecialchars($this->config['templates'][$info['template']]['description']);
			
				echo common::Link('Admin_Backgrounds_Changer', $this->config['templates'][$info['template']]['title'],'cmd=OrganizeTemplates&mall='.$info['template'],'data-cmd="gpabox" style="color:#8f9014;line-height:2;border-bottom:1px solid #aaaaaa;text-transform:uppercase;font-weight:bold;" title="'.$description.'"');
				
				if(isset($this->config['templates'][$info['template']]['addjs']))
					echo $_js;
				if(isset($this->config['templates'][$info['template']]['addcss']))
					echo $_css;
				
				echo '<br>';
				
				if(is_array($this->config['templates'][$info['template']])){
					self::Show_styleprops($this->config['templates'][$info['template']]);				
				}
				
			}else{
				
				echo " - ";				
				if(isset($info["def-template"])){
					echo self::AdminTextTranslates($info["def-template"]);
					//echo $info["def-template"];	
				
				}
			}
			
			echo '</td>';
			//TEMPLATES COLUMN END
			
			//PAGE BACKROUND AND STYLES
			echo '<td>';
			$br = false;
			if(isset($info['addjs'])){
					echo $_js; $br = true;
			}
			if(isset($info['addcss'])){
					echo $_css; $br = true;
			}
			if($br)
				echo '<br>';
			
			if(is_array($info)){
				self::Show_styleprops($info);				
			}

			echo '</td>';
			//PAGE BACKROUND AND STYLES COLUMN END
			
			//EDIT COLUMN LINKS	
			echo '<td>';			
			echo ' &nbsp; ';
			if($index == '-Default-')
				echo common::Link(common::indexToTitle(key($gp_titles)), $langmessage['edit'],'cmd=SelectBackgroundsDialog&defaulttempl=1&adminpage=1','data-cmd="gpabox"');
			else{
				echo common::Link(common::indexToTitle($index), $langmessage['edit'],'cmd=SelectBackgroundsDialog&adminpage=1','data-cmd="gpabox"');
			}
			echo '</td>';
			//EDIT COLUMN LINKS END
			
			echo '</tr>';
		}
		

		echo '</tbody>';
		echo '</table>';
		echo $this->AdminFooter();		
	}
	
	function Show_Config(){
		global $page, $langmessage, $gp_titles, $addon_current_id;

		self::Show_adminhead(true);
		  
		$gpabox = false;
		if(isset($_REQUEST['gpabox']))
			$gpabox = true;			
		
		$formaction = common::GetUrl('Admin_Backgrounds_Changer');
		$buttons =  '<button type="submit" name="cmd" value="SaveBackgroundsConfig" class="gpsubmit">'.$langmessage['save'].'</button>';
		$buttons .= '<button type="submit" name="cmd" value="DeleteBackgroundsStyle" class="gpsubmit">'.$langmessage['delete'].'</button>';

		if($gpabox){
			$formaction = "?";			
			$buttons =  '<button type="submit" name="cmd" value="SaveBackgroundsConfigInline" class="gpsubmit">'.$langmessage['save'].'</button>';
			//$buttons .= '<button type="submit" name="cmd" value="DeleteBackgroundsStyle" class="gpsubmit">'.$langmessage['delete'].'</button>';
			$buttons .= '<button id="rifSelectBackgroundsDialog" type="submit" name="cmd" value="SelectBackgroundsDialog" class="gpcancel" data-cmd="gpabox">'.$langmessage['cancel'].'</button> ';
		}
		
		echo '<form action="'.$formaction.'" method="post">';
		$hash = self::elfinder_hash_path($this->config['defaultpath']);
		echo '<label style="width:100%">'.self::AdminTextTranslates('Default background images directory').'<br/><input class="gpinput" style="margin-bottom:5px;width:60%" type="text" title="'.$hash.'" name="defaultpath" value="'.$this->config['defaultpath'].'" /> &#187; ';
		echo '<button class="gpsubmit rifBgSelectUploadFolder">'.self::AdminTextTranslates('Select Folder').' ('.self::AdminTextTranslates('Double click some files in folder').')</button> ';
		echo '</label><br/><br/>';
		
		echo '<label>'.self::AdminTextTranslates('Predefined colors').'<br/>';
		echo '<input style="width:160px;padding-left:30px;" class="Rif-BgColorChangerPicker gpinput" type="text" id="SelectBgColor" value="" /> </label><a id="rifBgAddPredefinedColor">'.self::AdminTextTranslates('add color').'</a>';
		echo '<div id="rifBgPredefinedColors">';
		
		$colorbox = '<span class="gpinput Rif-BgColorbox" style="background:%COLOR%;">%COLOR% <a>X</a><input type="hidden" name="BgColor[]" value="%COLOR%"></span>';
		$savedcolors = '[]';
		if(!empty($this->config['defaultcolors'])){
			$savedcolors = json_encode($this->config['defaultcolors']);
			foreach($this->config['defaultcolors'] as $color)
				echo str_replace('%COLOR%',$color,$colorbox);
		}
		
		echo '</div>';
		echo '<hr>';
				
		echo '<h3>'.self::AdminTextTranslates('Select Style').': </h3>';
		echo '<select class="gpselect" style="width:100%;font-weight:bold;" name="stylenr" id="rifSelectBgStylesForEdit">';
	
		if(!isset($_REQUEST['stylenr']))
			$nr =  key($this->config['styles']);
		else
			$nr =  $_REQUEST['stylenr'];
				
		foreach($this->config['styles'] as $n => $sets){
			$elementname = "";
			if($sets['htmlelement'] != "")
				$elementname = '('.self::AdminTextTranslates('Default Element').' - '.$sets['htmlelement'].')';
			
			$selected = '';
			if($n == $nr)
				$selected = ' selected="selected"';
			
			echo '<option value="'.$n.'"'.$selected.'>'.$sets['title'].' '.$elementname.'</option>';
		}

		echo '<option value="NewStyle">-- '.self::AdminTextTranslates('New Style').' --</option>'; //custom
		echo '</select>';
		echo '<hr>';
		
		echo '<div style="border:1px solid #222;padding:8px;border-radius: 8px;">';

		echo '<br><label style="width:100%">'.self::AdminTextTranslates('title').'<br/><input class="gpinput" style="margin-bottom:5px;width:60%" type="text" name="title" value="'.$this->config['styles'][$nr]['title'].'" /></label><br/>';
		if(!empty($this->config['styles'][$nr]['path']))
			$hash = self::elfinder_hash_path($this->config['styles'][$nr]['path']);		
		echo '<br><label style="width:100%">'.self::AdminTextTranslates('path').'<br/><input class="gpinput" style="margin-bottom:5px;width:60%" title="'.$hash.'" type="text" name="path" value="'.$this->config['styles'][$nr]['path'].'" />';
		echo '<button class="gpsubmit rifBgSelectUploadFolder">'.self::AdminTextTranslates('Select Folder').' ('.self::AdminTextTranslates('Double click some files in folder').')</button> ';
		echo '</label><br/>';
		echo '<br><label style="width:100%">'.self::AdminTextTranslates('htmlelement').'<br/><small style="font-size:10px;">'.self::AdminTextTranslates('htmlelement-help').'</small><br><input class="gpinput" style="margin-bottom:5px;width:60%" type="text" name="htmlelement" value="'.$this->config['styles'][$nr]['htmlelement'].'" /></label><br/>';
		
		$donotuse = array();
		if(!empty($this->config['styles'][$nr]['donotuse']))
			$donotuse = $this->config['styles'][$nr]['donotuse'];

		$styleelements = array("colors", "images", "selector");
		echo '<div><hr>'.self::AdminTextTranslates('Do not use').':<br>';
		foreach($styleelements as $what){
			$checked = "";
			if(in_array($what, $donotuse)){
				$checked = " checked";	
			}
			echo '<label>'.self::AdminTextTranslates('No '.$what).' <input type="checkbox" name="donotuse[]" value="'.$what.'"'.$checked.'></label>';
		}
		echo '<hr></div>';		
		
		//textareas
		echo '<div style="background:#dddddd; padding:10px; margin:0.5em 0; cursor:pointer" onclick="$(this).next(\'textarea\').slideToggle(\'slow\')">'.self::AdminTextTranslates('element_css').'</div>';
		echo '<textarea class="gpinput" class="gptextarea" name="element_css" cols="50" rows="6" style="width:100%;display:none;">'.htmlspecialchars($this->config['styles'][$nr]['element_css']).'</textarea><br/>';

		echo '<div style="background:#dddddd; padding:10px; margin:0.5em 0; cursor:pointer" onclick="$(this).next(\'textarea\').slideToggle(\'slow\')">'.self::AdminTextTranslates('element_js').'</div>';
		echo '<textarea class="gpinput"  class="gptextarea" name="element_js" cols="50" rows="6" style="width:100%;display:none;">'.htmlspecialchars($this->config['styles'][$nr]['element_js']).'</textarea><br/>';

		echo '<hr>';
		echo '<div style="background:#dddddd; padding:10px; margin:0.5em 0; cursor:pointer" onclick="$(this).next(\'textarea\').slideToggle(\'slow\')">'.self::AdminTextTranslates('additional_css').'</div>';
		echo '<textarea class="gpinput"  class="gptextarea" name="additional_css" cols="50" rows="6" style="width:100%;display:none;">'.htmlspecialchars($this->config['styles'][$nr]['additional_css']).'</textarea><br/>';

		echo '<div style="background:#dddddd; padding:10px; margin:0.5em 0; cursor:pointer" onclick="$(this).next(\'textarea\').slideToggle(\'slow\')">'.self::AdminTextTranslates('additional_js').'</div>';
		echo '<textarea class="gpinput" class="gptextarea" name="additional_js" cols="50" rows="6" style="width:100%;display:none;">'.htmlspecialchars($this->config['styles'][$nr]['additional_js']).'</textarea><br/>';
		
		echo '<div>'.self::AdminTextTranslates('Style description').'</div>';
		echo '<textarea class="gpinput" class="gptextarea" name="description" cols="20" rows="3" style="width:100%;">'.htmlspecialchars($this->config['styles'][$nr]['description']).'</textarea><br/>';
		$findinpages = self::CheckPageStyles($nr);
		if($findinpages)
			echo '<br>'.self::AdminTextTranslates('Used in pages').': <b>'.$findinpages.'</b><br><br>';
		
		echo $buttons;
		
		echo '</form>';		
		echo '</div>';
		echo $this->AdminFooter();
		
		$jcode = '$(".Rif-BgColorChangerPicker").minicolors({opacity:1, format: "rgb", swatches: '.$savedcolors.'});';
		$jcode .= '
		$("#rifBgAddPredefinedColor").click(function() {
			var inputcolor = $("label .Rif-BgColorChangerPicker");
			var colorelement = \''.$colorbox.'\';
			if(inputcolor.val() != ""){
				colorelement = colorelement.replace(/%COLOR%/g, inputcolor.val());
				$(colorelement).appendTo("#rifBgPredefinedColors");
				inputcolor.val("");				
			}		
		});
		$(document).on("click", "#rifBgPredefinedColors .Rif-BgColorbox a", function() {$(this).parent().remove();});
			';
		
		if(!isset($_REQUEST['gpabox']))
			$page->jQueryCode .= $jcode;
		else{
			echo '<script>'; 
			echo $jcode;
			echo '</script>';
		}
	}
	
	function OrganizeTemplates(){
		global $langmessage;
		
		$mall = $_GET['mall'];
		$template = $this->config['templates'][$mall];
		echo '<h3>'.self::AdminTextTranslates('Rename/Delete Template').'</h3>';	
		echo '<form method="post" action="?">';
		//echo '<input type="hidden" name="index" value="'.htmlspecialchars($index).'" />';
		echo '<span>'.self::AdminTextTranslates('Rename template title').':</span>';
		echo '<span style="padding-left: 50px;padding-right: 50px;"><input type="text" name="templatename" value="'.htmlspecialchars($template['title']).'" /> </span>';
		echo '<input type="hidden" value="'.$mall.'" name="template"/>';
		echo '<input type="hidden" value="SaveTemplate" name="cmd"/>';
		echo ' <button type="submit" name="save" value="SaveTemplate" class="gpsubmit">'.$langmessage['save'].'</button> ';
		echo ' <button type="submit" name="remove" value="RemoveTemplate" class="gpsubmit">'.$langmessage['remove'].'</button> ';
		echo '</form>';
		echo '<div><i>NB! '.self::AdminTextTranslates('When you delete a template, it is also deleted from all pages that used it.')."</i></div>";
		
	}

	
	function SaveBackgroundsConfigA($deletestyle=false){
		global $langmessage, $dataDir;
		self::SaveBackgroundsConfig($deletestyle);

	}
	
	function SaveOrganizeTemplates($deletestyle=false){
		global $langmessage, $dataDir;
		
 		$mall = $_POST['template'];
		
		//Rename
		if(isset($_POST['save'])){
			
			//message("save");
			if(empty($_POST['templatename'])){
				msg($langmessage['OOPS']);
				message(self::AdminTextTranslates('Rename template title is empty')."!?");
				return;			
			}
			
			$this->config['templates'][$mall]['title'] = $_POST['templatename'];
			if (gpFiles::SaveArray($this->config_file,'config',$this->config)) {
				msg($langmessage['SAVED']);
			}
			return;
		}
		
		//delete		
		if(isset($_POST['remove'])){
			
			foreach ($this->config['pages'] as $p => $k){
				if (isset($k["template"]) && $k["template"] == $mall)
					unset($this->config['pages'][$p]["template"]);
				if (empty($this->config['pages'][$p]))
					unset($this->config['pages'][$p]);
			}
			
 			unset($this->config['templates'][$mall]);

			if (gpFiles::SaveArray($this->config_file,'config',$this->config)) {
				message(self::AdminTextTranslates('The template was deleted and removed from all pages that used it.'));
				msg($langmessage['SAVED']);
			}
		}		
	}



}
