<?php

defined('is_running') or die('Not an entry point...');

class RifBackgroundsChanger{

	var $files;
	var $config;
	var $config_file;

	private $default_style = array(
		'path' => '',
		'title' => 'Body Background',
		'htmlelement' => 'body',
		'element_css' => "background-image:url('%IMG%');background-repeat:no-repeat;background-position: center center;background-attachment:fixed;background-size:cover;",
		'element_js' => '',
		'additional_js' => '',
		'additional_css' => '',
		'description' => '',
	);


	function __construct(){
		global $addonPathData;

		$this->config_file = $addonPathData.'/config.php';
		$this->Load_Config();

		if( common::LoggedIn() ){
			gpPlugin::js('bg-admin.js');
			gpPlugin::js('js/minicolor/jquery.minicolors.min.js');

			gpPlugin::css('bg-admin.css');
			gpPlugin::css('js/minicolor/jquery.minicolors.css');
			
			gpPlugin::js('js/uploader/jquery.dm-uploader.min.js');
			gpPlugin::js('js/uploader/uploader-ui.js');
			gpPlugin::css('js/uploader/uploader.css');
			
		}
	}

	function AdminTextTranslates($key){
		global $langmessage, $addon_current_id;
	
		if(isset($langmessage[$addon_current_id][$key]))
			return $langmessage[$addon_current_id][$key];

		return $key;
		
	}
	
	function AdminHeader($H1, $addlinks="", $H2=""){
		global $langmessage, $addon_current_id;
		
		$moreinfo = "";
		$moreinfo .= $H1;
		$moreinfo .= '<div style="padding-right:5px;float:right;">|';
		$moreinfo .= $addlinks;
		//$moreinfo .=  ' '.common::Link('Admin_Backgrounds_Changer',self::AdminTextTranslates('Admin page'));
		$moreinfo .= ' | <a style="padding-right:5px;font-weight:normal;font-style:italic;" target="_blank" href="'.$langmessage[$addon_current_id]["--ADMIN_LINKS--"]["--MoreInfoLink--"].'">'.self::AdminTextTranslates('More Info for plugin').'... | </a> ';
		$moreinfo .= '</div>';
		$moreinfo .= '<br><hr style="margin:2px;">';
		$moreinfo .= $H2;
		return $moreinfo;
	}
	
	function AdminFooter(){
		global $langmessage, $addon_current_id;
		$footer = '<div style="font-size:10px;border-top:1px solid #dfbfff;margin:5px;">';
		$footer .= $langmessage[$addon_current_id]["--ADMIN_LINKS--"]["--Plugin_Footer--"];
		$footer .= '</div>';
		return $footer;
	}
	
	public function PageRunScript($cmd){
		global $page;

		if( common::LoggedIn() ){
			$page->admin_links[] = array($page->title, self::AdminTextTranslates('Change Backgrounds'),'cmd=SelectBackgroundsDialog',' data-cmd="gpabox"');

			switch($cmd){
				case 'SelectBackgroundsDialog':				
					ob_start();
					$this->SelectBackgroundsDialog();
					$page->contentBuffer = ob_get_clean();
				return 'return';
				
				case 'SaveBackgroundsConfigInline':
					$this->SaveBackgroundsConfig();
					$this->SetBackgrounds();
				return '';
				
				case 'SaveBackgrounds':
					$this->SaveBackgrounds();
					$this->SetBackgrounds();
				return '';
			}
		}

		$this->SetBackgrounds();

		return $cmd;
	}

	//langpages for rifMultilang plugin
	//get langpages
	function LangPages(){
		global $ml_object;
		
		if (!isset($ml_object->RifMultilang))			
			return false;
		 if (empty($ml_object->lists))
			return false;
		
		$langpages = array();		
		foreach ($ml_object->lists as $langs){

			foreach ($langs as $l => $p){
				if($l == $ml_object->lang)
					continue;

				$langpages[$langs[$ml_object->lang]][$langs[$ml_object->lang]."-".$l] = $p;
			}
		}
		
		return $langpages;
	}	

	function SetToOtherPages() {
		 global $page, $title, $gp_index, $gp_menu;
		 
		 $index = $page->gp_index;

		//check if ...
		 if( !isset($this->config['pages']) || !isset($this->config['pages'][$index]) ){
			
			//menu levels
			$menuarraylevels = $this->MenuLevels($index, true);			 
			if(!empty($menuarraylevels)){
				//
				$lindex = false;
				foreach($menuarraylevels as $levelindex){
					if(isset($this->config['pages'][$levelindex]))
						$lindex = $levelindex;
				}
				 
				if($lindex)
					return $lindex;				 
			}
			

			//rif multilang plugin (not in menu)				
			if($this->LangPages()){	
				foreach($this->LangPages() as $defpage => $langpage){
				
					if(isset($this->config['pages'][$defpage])){
						foreach($langpage as $l => $p){
							if($p == $index && !isset($this->config['pages'][$p])){
								message($defpage);
								return $defpage;
								continue;
							}
						}
					}
				}
			}

			 
			//default if nothing
			if(!empty($this->config['default'])){
				//message("default");
				$this->config['pages'][$index] = $this->config['default'];
				$this->config['pages'][$index]['usedefault'] = 'usedefault';
			}else{
				return false;
			}
			 
		}
	 
		return $index;
	}
	 
	 function MenuLevels($pageindex, $getmenuarray=false) {
		global $gp_menu;
	
		$output				= array();
		$thisLevel			= -1;
		$last_index			= '';
		
		$pmenu = array_reverse(array_keys($gp_menu));		
		$rmenu = array_reverse(gpOutput::GetMenuArray('gpmenu'));
		
		$menucount = -1;

		
		foreach($rmenu as $index => $info){
			$level = $info['level'];
			
			$menucount ++;

			if( $thisLevel >= 0 ){
				
				if( $thisLevel == $level ){
					array_unshift($output, $pmenu[$menucount], $index);
					$last_index = $index;
					if( $thisLevel == 0 ){
						break;
					}
					$thisLevel--;
				}
			}

			if( $index == $pageindex ){

				array_unshift($output, $pmenu[$menucount], $index);
				$thisLevel = $level-1;
				$last_index = $index;
			} 
		}
	
		 return $output;
	 }	 
	 
	function SetBackgrounds() {
		global $page, $dataDir, $dirPrefix, $addonRelativeCode;
		
		$index = $this->SetToOtherPages();

		if(!$index)
			return;
		
		$css = "";
		$js = "";
		
		$settings = $this->FilterData($this->config['pages'][$index]);		
		
		foreach ($settings as $nr => $sets){
			
			if(!is_array($sets))
				continue;
			
			$changeelement = false;
			if(isset($sets['htmlelement']) && $sets['htmlelement'] != "")
				$changeelement = $sets['htmlelement'];
			

			$_css = $this->PageCSS($index, $nr, $changeelement);
			$js	= $this->PageJS($index, $nr, $changeelement);
			
			$check_img = false;
			if(isset($sets['img']) && $sets['img'] !="")
				$check_img = str_replace('%20',' ',$dataDir.$sets['img']);
		
			if($_css != ""){				
				if($check_img && file_exists($check_img) )
					$_css = str_replace('%IMG%', $dirPrefix.$sets['img'], $_css);
				else
					$_css = str_replace('%IMG%', $addonRelativeCode.'/0.png', $_css);
				
				if( isset($sets['color']) &&  $sets['color'] != "")
					$_css = str_replace('%COLOR%', $sets['color'], $_css);
				else
					$_css = str_replace('%COLOR%', "inherit", $_css);
				
				$css .= $_css;
			}

		}
//message("_________________");
		
		$css .= $this->PageCSS($index);
		$js .= $this->PageJS($index);

		$page->head .= "\n".'<style type="text/css">'."\n\n/* rifbackroundchanger CSS */\n".$css."\n</style>";
		//$page->head_script .=
		$page->jQueryCode .= "\n\n/* ________ rifbackroundchanger JS */\n\n".$js."\n\n/* ______*/\n\n";
	}


	function PageCSS($index, $nr=false, $changeelement=false){
		
		$out = "";
		if( !isset($this->config['pages'][$index]) ){
			return $out;
		}
		
		if(!$nr){
			if( isset($this->config['pages'][$index]['addcss'])) {
				$out .= $this->config['pages'][$index]['addcss'];			
			}						
			return $out;
		}
		
		if( isset($this->config['styles'][$nr]) ){
			$element = false;
			
			if($this->config['styles'][$nr]['htmlelement'] != "")
				$element = $this->config['styles'][$nr]['htmlelement'];
			
			if(!empty($changeelement))
				$element = $changeelement;
			
			if($element)
				$out .= "\n".$element."{\n".$this->config['styles'][$nr]['element_css']."\n}\n";
			else
				$out .= "";
			
			$out .= $this->config['styles'][$nr]['additional_css'];
			
			return $out;
		}

		return $out;
	}

	
	function PageJS($index, $nr=false, $changeelement=false){

		$out = "";
		if( !isset($this->config['pages'][$index]) ){
			return $out;
		}
		
		if(!$nr){
			if( isset($this->config['pages'][$index]['addjs'])) {
				$out .= $this->config['pages'][$index]['addjs'];			
			}						
			return $out;
		}
		
		if( isset($this->config['styles'][$nr]) ){
			$element = false;
			
			if($this->config['styles'][$nr]['htmlelement'] != "")
				$element = $this->config['styles'][$nr]['htmlelement'];
			
			if(!empty($changeelement))
				$element = $changeelement;
			
			if($element)
				$out .= str_replace('%ELEM%', $element, $this->config['styles'][$nr]['element_js']);
			else
				$out .= "";
			
			$out .= $this->config['styles'][$nr]['additional_js'];
			
			return $out;
		}

		return $out;
	}

	
	function Load_Config() {
		global $dataDir;
		
		if (file_exists($this->config_file)) {		
			include($this->config_file);
			$this->config = $config;
			
		} else {

			include('config-examples.php');
			$this->config = $config;
			
			if (file_exists($dataDir.'/data/_uploaded/'.$this->config['defaultpath'])){
				//do nothing
			}else{	
				if (mkdir($dataDir.'/data/_uploaded/'.$this->config['defaultpath'].'/', 0777, true)) {
					echo '_uploaded/BackgroundImages dir is done!<br>';
				}else{
					$this->config['defaultpath'] = '/image';
				}
			}
			
			gpFiles::SaveArray($this->config_file,'config',$this->config);
		}
	}

	
	function UseTemplate($index){
		
		if(isset($this->config['pages'][$index]['template'])){
			$template_id = $this->config['pages'][$index]['template'];
			if(isset($this->config['templates'][$template_id])){			
				return $this->config['templates'][$template_id];
			}
		}
		
		return false;
		
	}

	
	function FilterData($pagestyles, $templ_data=false){
		
		$filtering = array();	
		$usetemplate = false;
		
		if(!$templ_data){
			if(!isset($pagestyles))
				return $filtering;
			
			$templ_data = array();	
			if(isset($pagestyles['template']) && isset($this->config['templates'][$pagestyles['template']])){
				$templ_data = $this->config['templates'][$pagestyles['template']];
				
				foreach($templ_data as $sid => $ar){
					if(is_array($ar) && !isset($this->config['styles'][$sid])){
						unset($templ_data[$sid]);
					}
				}
				$usetemplate = true;
			}			
		}

		
		foreach($pagestyles as $key => $val){
			
			if(is_array($val)){
				
				foreach($val as $styleparam => $set){
					
					if(!isset($this->config['styles'][$key])){
						continue;
					}					
					if(!isset($templ_data[$key][$styleparam]) or (isset($templ_data[$key][$styleparam]) && $set != $templ_data[$key][$styleparam]))
						$filtering[$key][$styleparam] = $set;
				}
			
				if($usetemplate && isset($templ_data[$key])){
					if(!isset($filtering[$key]))
						$filtering[$key] = array();
					$filtering[$key] = $filtering[$key]+$templ_data[$key];
				}
				
			}else{
				
				if(!isset($templ_data[$key]) or (isset($templ_data[$key]) && $val != $templ_data[$key]))
					$filtering[$key] = $val;								
			}
		}
		
		if($usetemplate)
			return $filtering+$templ_data;
	
		return $filtering;
	}


	 function CheckPageStyles($check, $template=false){
		 global $page;
		 
		 $pagelinks = "";
		 $testination = $this->config['pages'];
		 
		 foreach($testination as $index => $param){
			 
			 if($index == $page->gp_index)
				 continue;

			 if(isset($param[$check]) && !$template)
				 $pagelinks .= " ".common::Link(common::indexToTitle($index), common::indexToTitle($index)).", ";
			 
			 else if(isset($param['template'])){
				 if(isset($this->config['templates'][$param['template']])){
					 if($template){
						 if($check == $param['template'])
							$pagelinks .= " ".common::Link(common::indexToTitle($index), common::indexToTitle($index)).", ";
						continue;
					 }
					 
					 if(array_key_exists($check, $this->config['templates'][$param['template']]))
						$pagelinks .= " ".common::Link(common::indexToTitle($index), common::indexToTitle($index)).", ";
				 }
			 }

		 }
		 
		 if($pagelinks == "")
			 return false;
		 
		 return $pagelinks;
		 
	 }

	 
	 function DoNotUse($value, $checkarray){
		 
		 if(empty($checkarray['donotuse']))
			 return false;
		
		if(in_array($value, $checkarray['donotuse']))
			return true;
		
		return false;
	 }

	 
	function SelectBackgroundsDialog(){
		global $langmessage, $title, $gp_index, $gp_titles;
		
		$index = $gp_index[$title];
		
		$stayindefault = "";
		$headertitle = '<h3>'.self::AdminTextTranslates('Change Page Backgrounds').' ('.common::indexToTitle($index).')</h3>';
		if(isset($_REQUEST['defaulttempl'])){
			unset($this->config['pages'][$index]);
			$stayindefault = "&defaulttempl=1";
			$headertitle = '<h3>'.self::AdminTextTranslates('Overwrite default').'</h3>';
		}
		
		$findindex = $this->SetToOtherPages();
		$usetemplate = $this->UseTemplate($index);

	
		includeFile('admin/admin_uploaded.php');		
	
		echo '<form method="post" action="?" id="rifBackgroundImagesInlineForm">';
		echo '<input type="hidden" name="index" value="'.htmlspecialchars($index).'" />';
		
		echo self::AdminHeader($headertitle, ' '.common::Link('Admin_Backgrounds_Changer',self::AdminTextTranslates('Admin page')));
		
		$usedefault = false;
		if(isset($this->config['pages'][$index]['usedefault']))
			$usedefault = true;

##LANG need change if not in menu default lang setigs is used			
		if($usedefault && $stayindefault == ""){
			echo '<i><b>'.self::AdminTextTranslates('This page uses the default backgrounds settings').'</b></i><br>'; 
		}
		
		if($usetemplate){			
			echo '<i id="rifBgTemplatetescruption"><b>NB! '.self::AdminTextTranslates('This page uses the backgrounds template').' </b>"'.$usetemplate['title'].'"</i><br><br>';
			echo '<input type="hidden" value="'.$this->config['pages'][$index]['template'].'" name="usetemplate"/>';			
		}
		
##LANG need change if not in menu default lang setigs is used			
		if($findindex && $index != $findindex){
			$pagelabel = common::indexToTitle($findindex);
			if(isset($gp_titles[$findindex]['label']))
				$pagelabel = $gp_titles[$findindex]['label'];
			echo '<i><b>NB! '.self::AdminTextTranslates('The backgrounds settings for this page are set here').' '.common::Link(common::indexToTitle($findindex), $pagelabel).'</b></i><br>';
		}
		
		if(!isset($this->config['pages'][$index]) or !isset($this->config['pages']) or $usedefault){
			if($stayindefault == "")
				echo '<i>'.self::AdminTextTranslates('If you want different backgrounds on the page, change the form below').'</i><br><br>';	
		}
		
		echo '<input type="text" style="position: fixed; left: -10000000px;" disabled/>';//remove autofocus
		echo '<select class="gpselect" style="width:100%;margin-bottom:3px;" name="template" id="rifBgsSelectTemplate">';
		
		echo '<option value="">-- '.self::AdminTextTranslates('Change background settings for this page').' --</option>'; //custom
		if(!empty($this->config['templates'])){	
		
			$tid = "0";
			
			if(isset($this->config['pages'][$index]['template']))
				$tid = $this->config['pages'][$index]['template'];
			if(isset($_REQUEST['template']) && isset($this->config['templates'][$_REQUEST['template']]) && !isset($_REQUEST['cancel']))
				$tid = $_REQUEST['template'];
						
			foreach($this->config['templates']  as $tn => $Tsets){
				$tarn = "";
				if(isset($this->config['pages'][$index]['template']) && $tn == $this->config['pages'][$index]['template'])
					$tarn = "* ";
				
				$selected = '';
				$text = $tarn.self::AdminTextTranslates('Select template');
									
				if($tn == $tid){
					$text = $tarn.self::AdminTextTranslates('Selected template');
					$selected = ' selected="selected"';
					if((isset($_REQUEST['usetemplate']) && $_REQUEST['usetemplate'] != $tn) or !$usetemplate)
						$this->config['pages'][$index] = $Tsets;
					$this->config['pages'][$index]['template'] = $tn;
				}
				
				echo '<option value="'.$tn.'"'.$selected.'>'.$text.' -- '.$Tsets['title'].'</option>';
			}
		}
		echo '<option value="remove">-- '.self::AdminTextTranslates('Cancel everything').' --</option>'; //custom
		echo '</select>';
		
		if(isset($this->config['pages'][$index]))
			$this->config['pages'][$index] = $this->FilterData($this->config['pages'][$index]);
		
		echo '<div id="rifBgsStylesSelectionContainer">';
		
		$this->StylesSelect($index, $usetemplate);
		
		echo '<hr/>';

		foreach($this->config['styles'] as $nr => $sets){
			
			$displaynr = "";
			if(!isset($this->config['pages'][$index][$nr])){	
				$displaynr = "display:none;";		
			}			
			echo '<div id="nr_'.$nr.'" style="'.$displaynr.'margin-bottom:5px;border:1px solid #aaaaaa;border-radius:5px;padding:5px;">';

			echo '<div style="padding-bottom:5px;border-bottom:1px solid #eeeeee;">';
			echo '<b style="display:inline-block;margin-bottom:2px;">'.$sets['title'].'</b><br>';
			

			if(!self::DoNotUse('colors' ,$sets)){
				$color = '';
				if(isset($this->config['pages'][$index][$nr]['color']) && $this->config['pages'][$index][$nr]['color'] != "")
					$color = $this->config['pages'][$index][$nr]['color'];
				echo '<input style="width:160px;padding-left:30px;" class="gpinput Rif-BgColorChangerPicker" type="text" name="color['.$nr.']" value="'.$color.'" />';
			}
			
			if(!self::DoNotUse('selector' ,$sets)){
				$element = "";
				if($sets['htmlelement'] != "")
					$element = $sets['htmlelement'];
				if(isset($this->config['pages'][$index][$nr]['htmlelement']) && $this->config['pages'][$index][$nr]['htmlelement'] != "")
					$element = $this->config['pages'][$index][$nr]['htmlelement'];
			
				if($sets['element_css'] == "" && $sets['element_js'] == ""){
				
				}else{
					echo self::AdminTextTranslates('Element').': <input class="gpinput" type="text" name="htmlelement['.$nr.']" value="'.htmlspecialchars($element).'" />';				
				}
			}
			
			$imgpath = $this->config['defaultpath']; 
			if(!empty($sets['path']))
				$imgpath = $sets['path']; 
			
			if(!self::DoNotUse('images' ,$sets)){				
				$hash = self::elfinder_hash_path($imgpath);
				echo '<a data-imguploadpath="'.$imgpath.'" href="RifBgChanger-uploader" class="gpsubmit rifBgUploadBgImage">'.self::AdminTextTranslates('Upload Image').'</a><span class="rifBgSelectUploadFolder" style="font-size:10px;"><a title="'.$hash.'">'.$imgpath.'</a></span>';			
			}
			
			echo '</div>';
			
				
			$imgpath = $this->config['defaultpath'];
			if(!empty($sets['path']))
				$imgpath = $sets['path'];
			
			$imgfile = "";
			if (isset($this->config['pages'][$index][$nr]['img']))
				$imgfile = $this->config['pages'][$index][$nr]['img'];			

			if(!empty($sets['description']))
				echo '<i>'.$sets['description'].'</i>';
			
			if(!self::DoNotUse('images' ,$sets))	
				$this->ImageSelect($index, $imgpath, $imgfile, $nr);
			
			echo '</div>';
		}
		echo '</div>';
		
		echo '<div style="margin-top:20px;">';		
		echo '<div id="rifSelectBgSaveHelptext1" style="display:none;padding:5px;">';
		echo '<i>'.self::AdminTextTranslates('Saves new default settings').'</i>';
		echo '</div>';
		echo '<div id="rifSelectBgSaveHelptext2" style="display:none;padding:5px;">';
		echo '<i>'.self::AdminTextTranslates('Updates the selected base template with new settings').'</i>';
		if(isset($this->config['pages'][$index]['template'])){			
			$findinpages = $this->CheckPageStyles($this->config['pages'][$index]['template'], true);
			if($findinpages)
				echo '<br>'.self::AdminTextTranslates('Used in pages').': <b>'.$findinpages.'</b>';					
		}
					
		echo '</div>';
		if(isset($_REQUEST['template']) && !$usetemplate)
			echo '<div id="rifSelectBgSaveHelptext3" style="display:block;padding:5px;"><i>NB! '.self::AdminTextTranslates('To edit or delete the selected basetemplate, you must first save it for this page.').'</i></div>';		


		echo '<div style="display:inline-block;width:30%;">';
		
		echo '<button type="submit" name="cmd" value="SaveBackgrounds" class="gpsubmit">'.$langmessage['save'].'</button> ';
		echo common::Link(common::indexToTitle($index), $langmessage['cancel'], 'cmd=SelectBackgroundsDialog'.$stayindefault, 'id="rifSelectBackgroundsDialog" class="gpcancel" data-cmd="gpabox"');
		echo '</div>';
		
		$savedefaulttext = self::AdminTextTranslates('Overwrite default');
		if(!isset($this->config['default']))
			$savedefaulttext = self::AdminTextTranslates('Save as default');
		
		echo '<div style="display:inline-block;float:right;width:300px;">';
		if($stayindefault==""){
			echo '<select style="width:300px;" class="gpselect" name="saveprops" id="rifSelectBgSaveProperties">';
			echo '<option value="">-- '.self::AdminTextTranslates('Save for this page').' --</option>';		
			echo '<option value="save_as_default">-- '.$savedefaulttext.' --</option>';		
			//if(!$usetemplate or (isset($_REQUEST['template']) && ($_REQUEST['template'] == "" or $_REQUEST['template'] == "remove")))		
			if($usetemplate)
				echo '<option value="overwrite_template">-- '.self::AdminTextTranslates('Overwrite template and use on this page').' --</option>';		
			echo '<option value="save_as_new_template">-- '.self::AdminTextTranslates('Save as new template').' --</option>';
			echo '</select>';		
			echo '<input style="margin-top:3px;background:#dfffbf;width:300px;display:none;" class="gpinput" type="text" name="save_as_new_template_name" value="" />';
		}else{ 
			echo '<input type="hidden" name="saveprops" value="save_as_default" />';
			echo '<input type="hidden" name="defaulttempl" value="1" />';
		}
		echo '</div>';
		echo '</div>';
		echo '</form>';
		echo $this->AdminFooter();
		echo '</div>';
		
		self::UploadImages();
		
		$savedcolors = '[]';
		if(!empty($this->config['defaultcolors']))
			$savedcolors = json_encode($this->config['defaultcolors']);
	
		echo '<script>';	
		echo '$(".Rif-BgColorChangerPicker").minicolors({opacity:1, format: "rgb", swatches: '.$savedcolors.'});';
		echo '</script>';
		
	}

	function elfinder_hash_path($path){
		$volumeId = 'l1_';

		$hash = $volumeId . rtrim(strtr(base64_encode($path), '+/=', '-_.'), '.');
		return $hash;
	}
	
	function UploadImagesShowLog($showlog, $log){
		if($showlog)
			return "ui_add_log(".$log.")";
		return "";
	}
	
	function UploadImages($imgpath=false, $showlog=false){
//$showlog=true;
		echo '<div style="display:none;">';
		echo '<div id="RifBgChanger-uploader" class="RifBgChanger-uploader">';
		 echo  '
          <div id="drag-and-drop-zone" class="dm-uploader">
            <h3 class="">'.self::AdminTextTranslates('Drag and drop files here').'</h3>

            <div class="selbtn gpsubmit">
                <span>'.self::AdminTextTranslates('Open the file Browser').'</span>
                <input type="file" title=\''.self::AdminTextTranslates('Click to add Files').'\' />
            </div>
          </div>';
        echo  '<div class="card h-100 rifBGuploadInfo">
            <div class="card-header">
              <b>'.self::AdminTextTranslates('File List').':</b>
            </div>

            <ul class="list-unstyled p-2 d-flex flex-column col" id="files">
              <li class="text-muted text-center empty">'.self::AdminTextTranslates('No files uploaded').'.</li>
            </ul>
          </div>';
		if($showlog){  
			echo '<div class="card h-100">  
				<div class="card-header">
				Debug Messages
				</div>

				<ul class="list-group list-group-flush" id="debug">
				<li class="list-group-item text-muted empty">Loading plugin....</li>
				</ul>
			</div>';
		}
		
		echo '</div>';
		echo '</div>';
		
		echo ' <!-- File item template -->
			<script type="text/html" id="files-template">
				<li class="media">
					<div class="media-body mb-1">
						<p class="mb-2">
						<strong>%%filename%%</strong> - '.self::AdminTextTranslates('Status').': <span class="text-muted">'.self::AdminTextTranslates('Waiting').'</span>
						</p>
						<div class="progress mb-2">
							<div class="progress-bar progress-bar-striped progress-bar-animated bg-primary" role="progressbar" style="width: 0%" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100">
							</div>
						</div>
						<hr class="mt-1 mb-1" />
					</div>
				</li>
			</script>';
		
		if($showlog){
			echo '<!-- Debug item template -->
				<script type="text/html" id="debug-template">
					<li class="list-group-item text-%%color%%"><strong>%%date%%</strong>: %%message%%</li>
				</script>';
		}	
		echo "<script>$(function(){
			
		$('.rifBgUploadBgImage').colorbox({
			inline:true, 
			href: '#RifBgChanger-uploader',
			width:666,
			height:300,
			className: 'RifBgChanger-uploaderPopup',
			onClosed: function () {	$('#drag-and-drop-zone').dmUploader('reset');},
		});
		
		$('.rifBgUploadBgImage').click(function(e) {
			
			var rifBgUploadBgImage = $(this).attr('data-imguploadpath');
					
			$(\"#drag-and-drop-zone\").dmUploader({ //
				url: 'Admin_Backgrounds_Changer?cmd=UploadFile',
				extraData: function() {
					return {'dir': rifBgUploadBgImage};
				},				
				maxFileSize: 3000000, // 3 Megs 
				
				extFilter: [\"jpg\", \"jpeg\", \"png\", \"gif\", \"svg\", \"svgz\"],
					onDragEnter: function(){
					// Happens when dragging something over the DnD area
					this.addClass('active');
				},
				onDragLeave: function(){
					// Happens when dragging something OUT of the DnD area
					this.removeClass('active');
				},";
		echo "	onInit: function(){					
					".$this->UploadImagesShowLog($showlog, "'Penguin initialized :)', 'info'")."
				},";
		echo "	onComplete: function(){
					// All files in the queue are processed (success or error)
					".$this->UploadImagesShowLog($showlog, "'All pending tranfers finished'")."
				},";
		echo "	onNewFile: function(id, file){
					// When a new file is added using the file selector or the DnD area
					".$this->UploadImagesShowLog($showlog, "'New file added #' + id")."
					ui_multi_add_file(id, file);
				},";
		echo "	onBeforeUpload: function(id){
					// about tho start uploading a file 
					".$this->UploadImagesShowLog($showlog, "'Starting the upload of #' + id")."
					ui_multi_update_file_status(id, 'uploading', '".self::AdminTextTranslates('Uploading...')."');
					ui_multi_update_file_progress(id, 0, '', true);
				},";
		echo "	onUploadCanceled: function(id) {
					// Happens when a file is directly canceled by the user.
					ui_multi_update_file_status(id, 'warning', '".self::AdminTextTranslates('Canceled by User')."');
					ui_multi_update_file_progress(id, 0, 'warning', false);
				},";
		echo "	onUploadProgress: function(id, percent){
					// Updating file progress
					ui_multi_update_file_progress(id, percent);
				},";
		echo "	onUploadSuccess: function(id, data){
					// A file was successfully uploaded
					//console.log(data);
					//console.log(rifBgUploadBgImage);
					".$this->UploadImagesShowLog($showlog, "'Server Response for file #' + id + ': ' + JSON.stringify(data)")."
					".$this->UploadImagesShowLog($showlog, "'Upload of file #' + id + ' COMPLETED', 'success'")."
					ui_multi_update_file_status(id, 'success', '".self::AdminTextTranslates('Upload Complete')."');
					ui_multi_update_file_progress(id, 100, 'success', false);
					
					var image = data.path;
 					var extension = '.'+image.split(/[.]+/).pop();
					var imgcontainer = '<label><input type=\"radio\" value=\"/data/_uploaded'+ image +'\"><img src=\"'+ gpBLink +'/data/_uploaded/image/thumbnails'+ image + extension+ '\" alt=\"'+ image +'\" title=\"'+ image + '\"><label>';
					$( '#rifBgsStylesSelectionContainer').find('.rifBackgroundImages').each(function( index ) {
						var inputname = $( this ).find('label').first().find('input').attr('name');
						var searchimgcontainer = $( this ).parent('div').find('.rifBgUploadBgImage').attr('data-imguploadpath');
						if (searchimgcontainer !== undefined && searchimgcontainer == rifBgUploadBgImage){
							console.log($( this ).find('label').first().find('input').attr('name'));
							//$( this ).append(imgcontainer).find('input').attr('name', inputname);
							$( this ).find('label').first().after(imgcontainer).find('input').attr('name', inputname);
						}
					}); 					

				},";
		echo "	onUploadError: function(id, xhr, status, message){
					ui_multi_update_file_status(id, 'danger', message);
					ui_multi_update_file_progress(id, 0, 'danger', false);  
				},";
		echo "	onFallbackMode: function(){
					// When the browser doesn't support this plugin :(
					".$this->UploadImagesShowLog($showlog, "'Plugin cant be used here, running Fallback callback', 'danger'")."
				},";
		echo "	onFileSizeError: function(file){
				".$this->UploadImagesShowLog($showlog, "'File \'' + file.name + '\' cannot be added: size excess limit', 'danger'")."
				}";
				
		echo "});});    });</script>";
		
	}
	

	function ImageSelect($index, $imgpath, $imgfile, $nr=false){
		global $title, $dataDir, $gp_index, $addonRelativeCode, $dirPrefix;
		
		//get the current image
		$curr_name	= '';
		$curr		= '';
		if( isset($this->config['pages'][$index]) ){
			$curr_name	= basename($imgfile);
			$curr		= $imgfile;
		}
		
		$radioname = 'image';
		if($nr)
			$radioname = 'image['.$nr.']';
		
		//display available images
		$path		= trim($imgpath,'/\\');
		$dir		= $dataDir.'/data/_uploaded/'.$path;
		$files		= scandir($dir);
		$curr_shown = false;
		
		$noimage = str_replace($dirPrefix,"",$addonRelativeCode).'/0.png';
		$checkednoimg = '';
		
		if($noimage == $curr or $curr == "" or !file_exists($dataDir.$curr)){
			$checkednoimg = ' checked';
			$curr_shown = true;
		}
		echo '<div class="rifBackgroundImages">';
		
		echo '<label>';
		echo '<input type="radio" name="'.$radioname.'" value="'.$noimage.'" '.$checkednoimg.' />';
		echo '<img src="'.$addonRelativeCode.'/NO.png" alt="NO IMAGE" title="/0.png" />';
		echo '</label>';
		
		foreach($files as $file){

			if( $file == '.' || $file == '..' ){
				continue;
			}

			$full		= $dir.'/'.$file;
			$img		= '/data/_uploaded/'.$path.'/'.$file;
		
			$imgfull		= common::GetDir($img);

			$thumb		= self::ThumbnailPath($imgfull);
			$checked	= '';

			if( !admin_uploaded::isImg($full) ){
				continue;
			}

			if( $curr == $img ){
				$checked = ' checked';
				$curr_shown = true;
			}

			echo '<label>';
			echo '<input type="radio" name="'.$radioname.'" value="'.htmlspecialchars($img).'" '.$checked.' />';
			echo '<img src="'.$thumb.'" alt="'.htmlspecialchars($file).'" title="'.htmlspecialchars($path.'/'.$file).'" />';
			echo '</label>';
		}


		// if choosen image is located in some other directory
		if( !$curr_shown && !empty($curr) ){
			$thumb		= self::ThumbnailPath($curr);
			echo '<label>';
			echo '<input type="radio" name="'.$radioname.'" value="'.htmlspecialchars($curr).'" checked />';
			echo '<img src="'.$thumb.'" alt="'.htmlspecialchars($curr_name).'" title="'.htmlspecialchars($curr).'" />';
			echo '</label>';
		}


		echo '</div>';
	}


	public static function ThumbnailPath($img){

		//already thumbnail path
		if( strpos($img,'/data/_uploaded/image/thumbnails') !== false ){
			return $img;
		}

		$dir_part = '/data/_uploaded/';
		$pos = strpos($img,$dir_part);
		if( $pos === false ){
			return $img;
		}

		return substr_replace($img,'/data/_uploaded/image/thumbnails/',$pos, strlen($dir_part) ).'.jpg';
	}


	function StylesSelect($index, $usetemplate){
		global $title, $langmessage;
		
		$showallfordefault = false;
		if(isset($_REQUEST['defaulttempl'])){
			$showallfordefault = true;
		}
		
		echo '<div id="rifSelectBgOpenSelectionsMenu">';
		echo '<span id="rifSelectBgOpenStyleSelections" style="display:block;border:1px solid #555555;border-radius:5px;padding:5px;cursor:pointer;">';
		echo '<b>'.self::AdminTextTranslates('Select styles and options').': </b>';

		$display = 'display:none;';
		if($usetemplate or isset($_REQUEST['template']))
			$display = 'display:block;';
		if($showallfordefault)
			$display = 'display:none;';
		
		echo '<i class="rifSelectBgStylesReadonly" style="'.$display.'font-size:10px;">'.self::AdminTextTranslates('You can not change the styles and settings for the page when using the base template').'</i>';
		
		echo '</span>';


		echo '<ul id="rifSelectBgStyleSelections" style="position:relative;display:none;background:#ededee;padding:5px !important;border-radius:5px;">';
		
		if( isset($this->config['pages'][$index]['template']) && $showallfordefault == false)
			echo '<li class="rifSelectBgStylesReadonly" style="display:block;position:absolute;width:90%;height:100%;top:0;background:rgba(237,237,238,0.5);"></li>';

		$gpabox = '&gpabox=1';
		$data_cmd= 'data-cmd="gpabox" ';
		if(isset($_REQUEST['adminpage'])){
			$gpabox = '';
			$data_cmd= '';
		}	
		foreach($this->config['styles'] as $nr => $sets){
			$elementname = "";
			if($sets['htmlelement'] != "")
				$elementname = '('.self::AdminTextTranslates('Default Element').' - '.$sets['htmlelement'].')';			
			$checked = '';
			if(isset($this->config['pages'][$index][$nr]))
				$checked = ' checked';

			$editlink = '&nbsp'.common::Link('Admin_Backgrounds_Changer', '['.strtoupper($langmessage['edit']).']', 'cmd=Show_Config'.$gpabox.'&stylenr='.$nr, $data_cmd.'style="font-weight:bold;font-size:8px;float:right;"');
			echo '<li><input type="checkbox" id="rifOpenStyleSelection" name="styles[]" value="'.$nr.'"'.$checked.'>&nbsp&nbsp&nbsp&nbsp&nbsp'.$sets['title'].'&nbsp'.$elementname.$editlink.'</li>';

			
		}
		
		$textarea_stylecss = 'display:none';
		$textarea_stylejs = 'display:none';
		$checked_css = '';
		$checked_js = '';
		$css = '';
		$js = '';
		
		if( isset($this->config['pages'][$index]['addcss']) ){
			$css = htmlspecialchars($this->config['pages'][$index]['addcss']);
			$checked_css = ' checked';
			$textarea_stylecss = '';
		}
		if( isset($this->config['pages'][$index]['addjs']) ){
			$js = htmlspecialchars($this->config['pages'][$index]['addjs']);
			$checked_js = ' checked';
			$textarea_stylejs = '';
		}
		
		$onlythis = ' <i>('.self::AdminTextTranslates('only for this page').')</i>';
		echo '<li style="border-top:1px solid #aaaaaa;margin-top:5px;"><input type="checkbox" id="rifSelectBgOpenAddCssCheck" name="check_addcss" value="1"'.$checked_css.'>&nbsp&nbsp&nbsp&nbsp&nbsp'.self::AdminTextTranslates('Add CSS syles').$onlythis.'</li>';
		echo '<li><input type="checkbox" id="rifSelectBgOpenAddJsCheck" name="check_addjs" value="1"'.$checked_js.'>&nbsp&nbsp&nbsp&nbsp&nbsp'.self::AdminTextTranslates('Add JS script').$onlythis.'</li>';
		echo '</ul>';

		echo '</div>';
		
		echo '<div style="margin-top:5px;margin-bottom:10px;border-top:1px solid #bbbbbb;border-bottom:1px solid #bbbbbb;">';
		echo '<div id="rifSelectBgOpenAddCss" style="'.$textarea_stylecss.'">';
		echo '<div id="rifSelectBgOpenStyleTextarea" style="padding:5px;background:#ededee;margin-bottom:2px;cursor:pointer;">'.self::AdminTextTranslates('Add CSS syles').'</div>';
		echo '<textarea style="display:none;width:100%;" name="addcss" cols="50" rows="6" class="gptextarea">';
		echo $css;
		echo '</textarea>';
		echo '</div>';
		
		echo '<div id="rifSelectBgOpenAddJs" style="'.$textarea_stylejs.'">';
		echo '<div id="rifSelectBgOpenJsTextarea" style="padding:5px;background:#ededee;margin-bottom:2px;cursor:pointer;">'.self::AdminTextTranslates('Add JS script').'</div>';
		echo '<textarea style="display:none;width:100%;" name="addjs" cols="50" rows="6" class="gptextarea"">';
		echo $js;
		echo '</textarea>';
		echo '</div>';
		echo '</div>';
	}


	function SaveBackgrounds(){
		global $langmessage;
		
		if(!isset($_POST['index']))
			return;
		
		$index = $_POST['index'];
		
		if($_POST['cmd'] == "SelectBackgroundsDialog"){	
			return;
		}
		
		if(isset($this->config['pages'][$index]) && isset($_POST['defaulttempl']))
			$temp = $this->config['pages'][$index];
		
		$pagestyles = array();
		
		if(isset($_POST['template']) && $_POST['template'] == "remove"){
			
			unset($this->config['pages'][$index]);
			
			if($_POST['saveprops'] == 'save_as_default')		
				unset($this->config['default']);
			
			if($_POST['saveprops'] == 'overwrite_template'){
				if(isset($_POST['usetemplate'])){							
					unset($this->config['templates'][$_POST['usetemplate']]);
				}
			}
			
		}else{
		
			if(trim($_POST['addcss']) != "" && isset($_POST['check_addcss']))
				$pagestyles['addcss'] = $_POST['addcss'];	
			
			if(trim($_POST['addjs']) != "" && isset($_POST['check_addjs']))
				$pagestyles['addjs'] = $_POST['addjs'];
			
			if(isset($_POST['styles'])){
				foreach($_POST['styles'] as $nr){
					//htmlspecialchars_decode
					$pagestyles[$nr] = array();
				
					if(isset($_POST['htmlelement'][$nr]) && trim($_POST['htmlelement'][$nr]) != "" && $_POST['htmlelement'][$nr] != $this->config['styles'][$nr]['htmlelement'])
						$pagestyles[$nr]['htmlelement'] =  $_POST['htmlelement'][$nr];
				
					if(isset($_POST['color'][$nr]) && trim($_POST['color'][$nr]) !== "")
						$pagestyles[$nr]['color'] =  $_POST['color'][$nr];
 

					if(isset($_POST['image'][$nr]))
						$pagestyles[$nr]['img'] =  $_POST['image'][$nr];
					
					$pagestyles[$nr]['usingstyle'] =  null;
			
				}
			}
			
			if($_POST['template'] != ""){
				$templid = $_POST['template'];
				
				if($_POST['saveprops'] == 'overwrite_template'){
					if(!empty($pagestyles)){
						$templatename = $this->config['templates'][$templid]['title'];
						$this->config['templates'][$templid] = $pagestyles;
						$this->config['templates'][$templid]['title'] = $templatename;
					}else
						unset($this->config['templates'][$templid]);
					
					unset($pagestyles);
				}
				
				if(isset($this->config['templates'][$templid])){
					$usetemplate = $templid;
				}
			}
	
			if(!empty($pagestyles) && $_POST['saveprops'] == 'save_as_new_template' && isset($_POST['save_as_new_template_name']) && trim($_POST['save_as_new_template_name']) != ""){
				$tid = time();
				$this->config['templates'][$tid] = $pagestyles;
				$this->config['templates'][$tid]['title'] = $_POST['save_as_new_template_name'];
				unset($pagestyles);
				$usetemplate = $tid;
			}
			
			if($_POST['saveprops'] == 'save_as_default'){
				if(!empty($pagestyles))
					$this->config['default'] = $pagestyles;
				else
					unset($this->config['default']);
				
				if(isset($temp))
					$pagestyles = $temp;
				else
					unset($pagestyles);
				
			}else{
				
				if(isset($usetemplate)){
					if(!empty($pagestyles)){						
						$pagestyles = $this->FilterData($pagestyles , $this->config['templates'][$usetemplate]);
					}					
					$pagestyles['template'] = $usetemplate;					
				}
				
			}
			
		}
		
		//message($this->config['dafault']);		

		if(empty($pagestyles))
			unset($this->config['pages'][$index]);
		else
			$this->config['pages'][$index] = $pagestyles;
		
		self::CleanData();
		
 		if( !gpFiles::SaveArray($this->config_file, 'config', $this->config) ){
			msg($langmessage['OOPS']);
		} 
	}
	
	function CheckImageDir($path){
		global $langmessage, $dataDir;
		
		if ($path=='') {
			$path='/';
		}
		if ($path[0]!='/') {
			$path='/'.$path;
		}
		if ($path[strlen($path)-1]=='/') {
			$path=substr($path,0,-1);
		}

		//check the directory
		$data_real	= realpath($dataDir);
		$dir		= realpath($dataDir.'/data/_uploaded/'.trim($path,'/\\'));

		if( !is_dir($dir) ){
			msg('Image directory is not a folder');
			return false;
		}

		if( strpos($dir,$data_real) !== 0 ){
			msg('Invalid image directory');
			return false;
		}
		
		return $path;
	}
	
	function SaveBackgroundsConfig($deletestyle=false){
		global $langmessage, $dataDir;

		$defaultpath = self::CheckImageDir(trim($_POST['defaultpath']));
		if(!$defaultpath)
			return false;
				
		
		$this->config['defaultpath'] = $defaultpath;

		if(isset($_POST['BgColor']) && is_array($_POST['BgColor']))
			$this->config['defaultcolors'] = $_POST['BgColor'];
		else
			$this->config['defaultcolors'] = "";
		
		if(empty($_POST['stylenr']))
			return false;
		
		$path = self::CheckImageDir(trim($_POST['path']));
		if(!$path or $path == $defaultpath or $path == "/")
			$path = "";
		
		if(trim($_POST['title']) == ""){
			msg('Pleace write title');
			return false;
		}
		
		if(trim($_POST['htmlelement']) == ""){
			$_POST['element_css'] = "";
			$_POST['element_js'] = "";
		}
		
		if (!isset($_POST['donotuse']) or !is_array($_POST['donotuse']))
			$_POST['donotuse'] = array();	

		if (empty($this->config['styles'])) {
			
			$this->config['style'][time()] = $this->default_style;
			
		}else{
			
			$nr = $_POST['stylenr'];
			
			if($deletestyle){
				unset($this->config['styles'][$nr]);
				$_REQUEST['cmd'] = 	'Show_Config';
				unset($_REQUEST['stylenr']);
			}else{				
				
				$savearray = array('path' => $path, 'title' => $_POST['title'],'htmlelement' => $_POST['htmlelement'],
				'element_css' => $_POST['element_css'],'element_js' => $_POST['element_js'],
				'additional_css' => $_POST['additional_css'],'additional_js' => $_POST['additional_js'], 'description' => $_POST['description'], 'donotuse' => $_POST['donotuse']);
		
				$nr = $_POST['stylenr'];		
				if($nr == "NewStyle"){
					$nr = time();			
				}			
				$this->config['styles'][$nr] = $savearray;
				$_REQUEST['stylenr'] = 	$nr;
			}			
		}

		self::CleanData();

		if (gpFiles::SaveArray($this->config_file,'config',$this->config)) {
			msg($langmessage['SAVED']);
		}
	}
	
	function CleanData(){
		global $gp_titles;
		foreach($this->config["pages"] as $index => $data){
			if (!isset($gp_titles[$index]))
				unset($this->config["pages"][$index]);	
		}	
	}

	static function BackwardsCompat(){}

}
