<?php
defined('is_running') or die('Not an entry point...');

class RifBackgroundsChanger_Languages{
	
	//admin texts translation works without rif-multilang plugin 
	static function Translates($path){		
		global $config, $langmessage, $addonPathCode, $gpAdmin, $addon_current_id;

		if( common::loggedIn() ){

			if(!isset($langmessage[$addon_current_id])){
				
				$langsdir = $addonPathCode."/languages/";//do not change it
				$langmessage[$addon_current_id] = array();	
				$adminlang = $config["language"];
			
				// check if adminlang is set (If rif-multilang plugin is installed)
				$users	= gpFiles::Get('_site/users');
				if(!empty($users[$gpAdmin['username']]['adminlang'])){
					$adminlang = $users[$gpAdmin['username']]['adminlang'];			
				}
				
				//rif-multilang plugin (change adminlang link)
				if(isset($_GET['adminlang']))
					$adminlang = $_GET['adminlang'];
			
				//include default language file
				$langmessage[$addon_current_id] = self::PluginLangmessages($langsdir."en.main.inc");
				
				//overwrite default langfile 
				if(file_exists($addonPathCode."/languages/".$adminlang.".main.inc")){					
					$addlangmessages = self::PluginLangmessages($langsdir.$adminlang.".main.inc");
					$langmessage[$addon_current_id] = self::ThreeDimArray($addlangmessages, $langmessage[$addon_current_id]);
				}
			}
		}
		
		self::pluginstuninst($path);
		self::GetPlugMessage($path);
		
		return $path;
	}
	
	//plugin langmessage file include
	static function PluginLangmessages($Path){
		global $addon_current_id;
		
		$langmessage = array();
		include($Path);
		
		//Check langmessage pluginid key if exists
		if(isset($langmessage[$addon_current_id]) && is_array($langmessage[$addon_current_id]))
			$langmessage = $langmessage[$addon_current_id];
		
		return $langmessage;
	}
	
	static function ThreeDimArray($addlangmessages, $langmessages){
		
		foreach($addlangmessages as $key => $val){
			if(!is_array($val))
				continue;
		
			if(!isset($langmessages[$key]))
				$langmessages[$key] = array();
			$addlangmessages[$key] = $addlangmessages[$key]+$langmessages[$key];
			
			foreach($val as $_key => $_val){
				if(!is_array($_val))
					continue;
				if(!isset($langmessages[$key][$_key]))
					$langmessages[$key][$_key] = array();
				$addlangmessages[$key][$_key] = $addlangmessages[$key][$_key]+$langmessages[$key][$_key];				
			}
		
		}
		return $addlangmessages+$langmessages;
	}
	
	static function pluginstuninst($path){
		global $config, $langmessage, $addon_current_id, $addonPathData, $addon_current_version, $dirPrefix;
		//PLEASE ... DONT MODIFY THIS FUNCTION (... or donate if you really want to change it)!
		$nst = false;
		$instfile = $addonPathData.'/install';
		if(!file_exists($instfile))
			$nst = 'install';
		
		if($path == 'Admin_Addons' or $path == 'Admin/Addons'){
		
			//Local install		
			if(isset($_REQUEST['cmd']) && $_REQUEST['cmd'] == "LocalInstall"){										
				if(isset($_REQUEST['source']) && isset($config['addons'][$_REQUEST['source']]['id']) && $config['addons'][$_REQUEST['source']]['id'] == $addon_current_id){
					$nst = 'update';
				
				}  
			}
		
			//Remote install
			if(isset($_POST['cmd']) && ($_POST['cmd'] == "RemoteInstallConfirmed" or $_POST['cmd'] == "remote_install_confirmed")){	
				if (isset($_POST['id']) && $_POST['id'] == $addon_current_id){
					$nst = 'update';
				
				} 					
			}
		
			//uninstall
			if(isset($_REQUEST['cmd']) && $_REQUEST['cmd'] == 'confirm_uninstall'){
			
				if(isset($_REQUEST['addon']) && isset($config['addons'][$_REQUEST['addon']]['id'])  && $config['addons'][$_REQUEST['addon']]['id'] == $addon_current_id){ 
					$nst = 'uninstall';

				}			
			}

		}
	
		if(!$nst)
			return false;
		
		$url = "";
		if(isset($langmessage[$addon_current_id]["--ADMIN_LINKS--"]["--MoreInfoLink--"]))
			$url = $langmessage[$addon_current_id]["--ADMIN_LINKS--"]["--MoreInfoLink--"];
		if($url == "")
			return false;
		
		$q = "";
		$c = "TypesetterPlugin".$addon_current_id;
		$hashed_id = md5($c.strrev($nst.$addon_current_id));

		$array = json_encode(array($hashed_id,$addon_current_id,$addon_current_version,$_SERVER['SERVER_NAME'].'/'.$dirPrefix,$config['language'],urlencode($url),gpversion));	
		if($url && $url != "")
			$q = '?pluginstuninst='.base64_encode($array);	
		$content = @file_get_contents($url.$q);
		if(strpos($content, '<!--Rif plugins messages-->') !== false){
			message($content);
		}

		gpFiles::Save($instfile, "install");
		return true;	
	}
	
	static function GetPlugMessage($path){
		global $config,$addonPathData,$addon_current_id,$addon_current_version,$dataDir,$langmessage,$dirPrefix;

		//PLEASE ... DONT MODIFY OR REMOVE THIS FUNCTION (... or donate if you really want to change it)!
		// this send plugin update and other important messages for you		
		if(!common::loggedIn()){
			return;			
		}
		
		if(substr(strtolower($path), 0, 6) == 'admin_' or substr(strtolower($path), 0, 6) == 'admin/')
			return;
		if(isset($_REQUEST['cmd']) or isset($_REQUEST['jsoncallback']))
			return;

		if(!file_exists($addonPathData.'/install')){
			message("Plugin maybe not installed correctly?");
			return;
		}
	
		if(!isset($langmessage[$addon_current_id]["--ADMIN_LINKS--"]["--MoreInfoLink--"])){
			message("Plugin maybe not installed correctly?");
			return;
		}
		
		global $gpAdmin;		
		$md = $dataDir.'/data/_messages/'.$gpAdmin['username'];
		if(!file_exists($md)){
			if (!mkdir($md, 0777, true)) {
				return false;
			}
		}
				
		if(file_exists($md."/conf.inc")){
			include($md."/conf.inc");
			$confm = $messageconf;
			unset($messageconf);
			
			$timef = glob($md."/*.time");
			if(empty($timef[0])){
				$tfname = time()+$confm['waitminits'];
				file_put_contents($md."/".$tfname.".time", "");
				return;
			}			
		}	
			
		$rm = false;
		if(isset($_POST["RifPluginMessageRemover"])) 
			$rm = $_POST["RifPluginMessageRemover"];		
		if($rm && $rm != $addon_current_id)
			return;
		
		$GoCheck = false;
		if(!isset($confm['lastcheck'][$addon_current_id]) && !$rm){
			$GoCheck = true;
		}elseif(time() > $confm['lastcheck'][$addon_current_id] && !$rm){		
			$GoCheck = true;
		}else{
		
			$mfiles = glob($md."/*.php");
			if(empty($mfiles))
				return;
					
			$waitf = glob($md."/*.wait");
			$wait = false;
			$time = basename($timef[0], ".time");
			if(!empty($waitf[0])){				
				$wait = basename($waitf[0], ".wait");
				$waitids = explode("-", $wait);					
			}					

			if(!$rm){
				if($time > time()){ //
					return;
				}else{
					if($wait && file_exists($waitf[0])){
						if(count($waitids) >= count($mfiles)){
							unlink($waitf[0]);			
							$tfname = time()+$confm['waitagain'];
							rename($timef[0], $md."/".$tfname.".time");
							return;
						}
					}	
				}
			}
			
			$currentfile = glob($md."/".$addon_current_id."*.php");					
			if(!empty($currentfile[0])){
				
				$curnam = explode("-", basename($currentfile[0], ".php"));									
				foreach ($mfiles as $filename) {
			
					$fnam = explode("-", basename($filename, ".php"));
					
					if($fnam[2] == "0"){
						unlink($filename);
						continue;
					}
							
					if($wait && in_array($addon_current_id, $waitids) && !$rm)
						continue;
								
					if($fnam[0] == $addon_current_id){
						$contents = gpFiles::Get($filename, 'message');
						if(!$wait)
							file_put_contents($md."/".$addon_current_id.".wait", "");
						else if(!in_array($addon_current_id, $waitids)) 
							rename($waitf[0], $md."/".$addon_current_id."-".$wait.".wait");
					}
					
					if($fnam[0] == $addon_current_id or $fnam[1] == $curnam[1]){				
						if($fnam[2] != "button"){
							$count = $fnam[2]-1;							
						}else{
							$count = "button";
							if(!$rm)
								continue;								
							if($curnam[1] == $rm or $curnam[0] == $rm)
								$count = "0";
						}																	
						rename($filename, $md."/".$fnam[0].'-'.$fnam[1].'-'.$count.'.php');
					}
						
				}
						
				if(!empty($contents['content'])){
					$tfname = time()+$confm['waitminits'];
					rename($timef[0], $md."/".$tfname.".time");
				}					
			}				
		}

		
		if($GoCheck){
			$_add = "";
			$url = "";
			if(isset($langmessage[$addon_current_id]["--ADMIN_LINKS--"]["--MoreInfoLink--"]))
				$url = $langmessage[$addon_current_id]["--ADMIN_LINKS--"]["--MoreInfoLink--"];		

			$language = $config['language'];
			$u = gpFiles::Get('_site/users');
			if(!empty($u[$gpAdmin['username']]['adminlang'])){
				$language = $u[$gpAdmin['username']]['adminlang'];			
			}
			
			$array = json_encode(array($addon_current_id,$language,$addon_current_version,$_SERVER['SERVER_NAME'],$dirPrefix,$_add));
			$q = '?rif_plugins_messages='.base64_encode($array);

			$pcontent = @file_get_contents($url.$q);
			if(strpos($pcontent, '<!--Rif plugins JSON messages-->') !== false){
				$json = str_replace('<!--Rif plugins JSON messages-->', "", $pcontent);
				$json = trim($json);
				$c = json_decode($json, true);
					
				if(!file_exists($md."/".$c['timeid'].".id")){
					$idf = glob($md."/*.id");
					if(!empty($idf[0])){
						array_map('unlink', glob($md."/*"));
							//return;
					}					
					file_put_contents($md."/".$c['timeid'].".id", "");
					$confm = array();
				}

				$confm['timetocheck'] = $c['timetocheck'];
				$confm['waitminits'] = $c['waitminits'];
				$confm['waitagain'] = $c['waitagain'];
				
				if(!file_exists($md."/".$c['pl_timeid'].".id".$c['id'])){
					$idp = glob($md."/*.id".$c['id']);
					if(isset($c['oldid']))
						$idpo = glob($md."/*.id".$c['oldid']);
					
					if(!empty($idp[0]) && file_exists($idp[0])){
						unlink($idp[0]);
						if(!empty($idpo[0]) && file_exists($idpo[0]))
							unlink($idpo[0]);
					
						foreach(glob($md."/*.php") as $filename){
							$fnamp = explode("-", basename($filename, ".php"));
							if( (isset($c['idlink']) && $c['idlink'] == $fnamp[1]) or $c['id'] == $fnamp[0] or (isset($c['oldid']) && ($c['oldid'] == $fnamp[0]) or $c['id'] == $fnamp[1]) ){
									unlink($filename);
							}
							
						}						
					}
					
					file_put_contents($md."/".$c['pl_timeid'].".id".$c['id'], "");
				
					$f = $c['id'].'-'.$c['id'].'-'.$c['expires'];
					if(isset($c['idlink']))
						$f = $c['id'].'-'.$c['idlink'].'-'.$c['expires'];
								
					gpFiles::SaveArray($md."/".$f.".php",'message',$c);					
				}				
			}
			
			if(!empty($confm['timetocheck'])){
				$confm['lastcheck'][$addon_current_id] = time()+$confm['timetocheck'];
				gpFiles::SaveArray($md."/conf.inc",'messageconf',$confm);
			}else{
				$conf['timetocheck'] = 120;//43200 - 12 tundi
				$conf['waitminits'] = 60;//120 - 2 min
				$conf['waitagain'] = 60;//300 - 5 min				
				gpFiles::SaveArray($md."/conf.inc",'messageconf',$conf);
			}

			if(!empty($timef[0]) && file_exists($timef[0])){
				unlink($timef[0]);
			}
			
			return;
		}
		
		if(!empty($contents['content'])){
			message(str_replace("{user}"," ".$gpAdmin['username']." ",$contents['content']));		
		}		
	}

}